searchNodes=[{"ref":"Packmatic.html","title":"Packmatic","type":"module","doc":"Top-level module holding the Packmatic library, which provides ZIP-oriented stream aggregation services from various sources."},{"ref":"Packmatic.html#build_stream/2","title":"Packmatic.build_stream/2","type":"function","doc":"Builds a Stream which can be consumed to construct a ZIP file from various sources, as specified in the Manifest. When buinding the Stream, options can be passed to configure how the Encoder should behave when Source acquisition fails. Examples stream = Packmatic.build_stream([ {{:file, &quot;/tmp/hello.pdf&quot;}, &quot;hello.pdf&quot;}, {{:file, &quot;/tmp/world.pdf&quot;}, &quot;world.pdf&quot;} ]) stream = Packmatic.build_stream([ {{:file, &quot;/tmp/htllo.pdf&quot;}, &quot;hello.pdf&quot;}, {{:file, &quot;/tmp/world.pdf&quot;}, &quot;world.pdf&quot;} ], on_error: :skip)"},{"ref":"Packmatic.html#t:manifest/0","title":"Packmatic.manifest/0","type":"type","doc":""},{"ref":"Packmatic.html#t:options/0","title":"Packmatic.options/0","type":"type","doc":""},{"ref":"Packmatic.html#t:source_entry/0","title":"Packmatic.source_entry/0","type":"type","doc":""},{"ref":"Packmatic.html#t:source_option/0","title":"Packmatic.source_option/0","type":"type","doc":""},{"ref":"Packmatic.html#t:source_path/0","title":"Packmatic.source_path/0","type":"type","doc":""},{"ref":"Packmatic.html#t:stream_entry/0","title":"Packmatic.stream_entry/0","type":"type","doc":""},{"ref":"Packmatic.html#t:stream_entry_extended/0","title":"Packmatic.stream_entry_extended/0","type":"type","doc":""},{"ref":"Packmatic.Conn.html","title":"Packmatic.Conn","type":"module","doc":"Contains convenience functions which can be used to easily integrate a Zip stream with Plug-using applications such as Phoenix."},{"ref":"Packmatic.Conn.html#send_chunked/3","title":"Packmatic.Conn.send_chunked/3","type":"function","doc":"Convenience function which sends the stream to the conn. Examples stream |&gt; Packmatic.Conn.send_chunked(conn, &quot;download.zip&quot;)"},{"ref":"Packmatic.Encoder.html","title":"Packmatic.Encoder","type":"module","doc":"Holds logic which can be used to put together a ZIP file in an interative fashion, suitable for wrapping within a Stream. The format of ZIP files emitted by Packmatic.Encoder is documented under the modules implementing the Packmatic.Field protocol. The Encoder is wrapped in Stream.resource/3 for consumption as an Elixir Stream, under Packmatic.build_stream/1. Further, the Stream can be used with Plug.Conn to serve a chunked connection easily, as provided in Packmatic.Conn.send_chunked/3. The Encoder has three statuses: Encoding, where each Entry within the Manifest is transformed to a Source, which is subsequently consumed. If the on_error option is set to :skip when building the stream, then sources which have raised error are skipped, although at this time portions of the source may have already been sent. Otherwise, and as the default behaviour, an uncaught exception will be raised and the consumer of the Stream will crash. During Encoding, content is dynamically deflated. Journaling, where each successfully encoded Entry is journaled again at the end of the archive, with the Central Directory structure. Both Zip and Zip64 formats are used for maximum flexibility. In case the on_error option is set to :skip, any source which has raised an error during its consumption will not be journaled. Due to the nature of streaming archives, this may still leave portions of unusable data within the archive. Done, which is the terminal status."},{"ref":"Packmatic.Encoder.html#iolist_size/1","title":"Packmatic.Encoder.iolist_size/1","type":"function","doc":"See :erlang.iolist_size/1."},{"ref":"Packmatic.Encoder.html#stream_after/2","title":"Packmatic.Encoder.stream_after/2","type":"function","doc":""},{"ref":"Packmatic.Encoder.html#stream_next/2","title":"Packmatic.Encoder.stream_next/2","type":"function","doc":"Iterates the Stream. When the Stream is in :encoding status, this function may continue encoding of the current item, or advance to the next item, or advance to the :journaling status when there are no further items to encode. When the Stream is in :journaling status, this function may continue journaling the next item, or advance to the :done status. When the Stream is in :done status, it can not be iterated further."},{"ref":"Packmatic.Encoder.html#stream_start/2","title":"Packmatic.Encoder.stream_start/2","type":"function","doc":"Starts the Stream by validating the Manifest and initialising the Encoding State."},{"ref":"Packmatic.Encoder.html#t:error/0","title":"Packmatic.Encoder.error/0","type":"type","doc":""},{"ref":"Packmatic.Encoder.html#t:manifest/0","title":"Packmatic.Encoder.manifest/0","type":"type","doc":""},{"ref":"Packmatic.Encoder.html#t:ok_done/0","title":"Packmatic.Encoder.ok_done/0","type":"type","doc":""},{"ref":"Packmatic.Encoder.html#t:ok_encoding/0","title":"Packmatic.Encoder.ok_encoding/0","type":"type","doc":""},{"ref":"Packmatic.Encoder.html#t:ok_halt/0","title":"Packmatic.Encoder.ok_halt/0","type":"type","doc":""},{"ref":"Packmatic.Encoder.html#t:ok_journaling/0","title":"Packmatic.Encoder.ok_journaling/0","type":"type","doc":""},{"ref":"Packmatic.Encoder.html#t:ok_start_encoding/0","title":"Packmatic.Encoder.ok_start_encoding/0","type":"type","doc":""},{"ref":"Packmatic.Encoder.html#t:options/0","title":"Packmatic.Encoder.options/0","type":"type","doc":""},{"ref":"Packmatic.Encoder.html#t:state_encoding/0","title":"Packmatic.Encoder.state_encoding/0","type":"type","doc":""},{"ref":"Packmatic.Encoder.html#t:state_journaling/0","title":"Packmatic.Encoder.state_journaling/0","type":"type","doc":""},{"ref":"Packmatic.Field.Central.DirectoryEnd.html","title":"Packmatic.Field.Central.DirectoryEnd","type":"module","doc":"Represents the End of Central Directory record. Within this implementation, the Zip64 standard always adopted, so the Zip64 End of Central Directory Record, and the Zip64 End of Central Directory Record Locator, are also emitted. Structure Zip64 End of Central Directory Record SizeContent 4 bytesSignature 8 bytesSize of Record (excluding leading 12 bytes) 2 bytesVersion made by 2 bytesVersion needed to extract 4 bytesNumber of this disk 4 bytesNumber of the disk with the start of the Central Directory 8 bytesTotal number of entries in the Central Directory on this disk 8 bytesTotal number of entries in the Central Directory 8 bytesSize of the Central Directory 8 bytesOffset of start of Central Directory with respect to the starting disk number VariableZip64 extensible data sector (variable, but empty in this implementation) Zip64 End of Central Directory Locator SizeContent 4 bytesSignature 4 bytesNumber of the disk with the start of the Zip64 End of Central Directory 8 bytesRelative offset of the Zip64 End of Central Directory record 4 bytesTotal number of disks End of Central Directory Record SizeContent 4 bytesSignature 2 bytesNumber of this disk 2 bytesNumber of the disk with the start of the Central Directory 2 bytesTotal number of entries in the Central Directory on this disk 2 bytesTotal number of entries in the Central Directory 4 bytesSize of the Central Directory 4 bytesOffset of start of Central Directory with respect to the starting disk number 2 bytesFile comment length VariableFile comment (64KB max.) Notes File comments are not emitted by Packmatic."},{"ref":"Packmatic.Field.Central.DirectoryEnd.html#t:t/0","title":"Packmatic.Field.Central.DirectoryEnd.t/0","type":"type","doc":""},{"ref":"Packmatic.Field.Central.FileHeader.html","title":"Packmatic.Field.Central.FileHeader","type":"module","doc":"Represents the Central Directory File Header, which is part of the Central Directory that is emitted after all successfully encoded files have been incorporated into the ZIP stream. Structure Central Directory File Header SizeContent 4 bytesSignature 1 byteVersion made by - ZIP Specification Version 1 byteVersion made by - Environment 2 bytesVersion needed to extract 2 bytesGeneral Purpose Flag 2 bytesCompression Method (0 = No Compression; 8 = Deflated) 2 bytesModification Time (DOS Format) 2 bytesModification Date (DOS Format) 4 bytesChecksum (CRC-32) 4 bytesCompressed Size (Placeholder; value set in Zip64 Extended Information Extra Field) 4 bytesOriginal Size (Placeholder; value set in Zip64 Extended Information Extra Field) 2 bytesFile Path Length (Bytes) 2 bytesExtra Fields Length (Bytes) 2 bytesFile Comment Length (Bytes) 2 bytesStarting Disk Number for File 2 bytesInternal Attrbutes 4 bytesExternal Attrbutes 4 bytesOffset of Local File Header VariableFile Path VariableExtra Fields VariableFile Comment Notes The General Purpose Flag has the following bits set. Bit 3: Indicating a Streaming Archive; Data Descriptor is used, and the Local File Header has no Size or CRC information. Bit 11: Language encoding flag, indicating that the Filename and Comment are both already in UTF-8. As per APPNOTE, the presence of this flag obviates the need to emit a separate Info-ZIP Unicode Path Extra Field. The Compressed Size and Original Size fields are both set to 0xFF 0xFF 0xFF 0xFF, in order to force the real sizes, set in the Zip64 Extended Information Extra Field (provided by Packmatic.Field.Shared.ExtendedInformation) to be used. The following Extra Fields are emitted: Extended Timestamp, see Packmatic.Field.Shared.ExtendedTimestamp Zip64 Extended Information, see Packmatic.Field.Shared.ExtendedInformation File comments are not emitted by Packmatic."},{"ref":"Packmatic.Field.Central.FileHeader.html#t:t/0","title":"Packmatic.Field.Central.FileHeader.t/0","type":"type","doc":""},{"ref":"Packmatic.Field.Local.DataDescriptor.html","title":"Packmatic.Field.Local.DataDescriptor","type":"module","doc":"Represents the Data Descriptor, which is used to facilitate streaming. This is requried since Packmatic assembles the files on the fly, so it does not know the size until the entire source has been read. Structure Data Descriptor SizeContent 4 bytesSignature 4 bytesChecksum (CRC-32) 4 bytesCompressed Size (Bytes) 4 bytesOriginal Size (Bytes) Notes Although the APPNOTE indicates that Zip64 format should be used, 8-byte sizes crash the Unarchiver process on macOS High Sierra, but a truncated one works totally fine."},{"ref":"Packmatic.Field.Local.DataDescriptor.html#t:t/0","title":"Packmatic.Field.Local.DataDescriptor.t/0","type":"type","doc":""},{"ref":"Packmatic.Field.Local.FileHeader.html","title":"Packmatic.Field.Local.FileHeader","type":"module","doc":"Represents the Local File Header, which is emitted before the content of each file is incorporated into the ZIP stream. Structure Local File Header SizeContent 4 bytesSignature 2 bytesVersion needed to extract 2 bytesGeneral Purpose Flag 2 bytesCompression Method (0 = No Compression; 8 = Deflated) 2 bytesModification Time (DOS Format) 2 bytesModification Date (DOS Format) 4 bytesChecksum (CRC-32; 0 since Data Descriptor is used) 4 bytesCompressed Size (Bytes; 0 since Data Descriptor is used) 4 bytesOriginal Size (Bytes; 0 since Data Descriptor is used) 2 bytesFile Path Length (Bytes) 2 bytesExtra Fields Length (Bytes) VariableFile Path VariableExtra Fields Notes The General Purpose Flag has the following bits set. Bit 3: Indicating a Streaming Archive; Data Descriptor is used, and the Local File Header has no Size or CRC information. Bit 11: Language encoding flag, indicating that the Filename and Comment are both already in UTF-8. As per APPNOTE, the presence of this flag obviates the need to emit a separate Info-ZIP Unicode Path Extra Field. The Checksum, Compressed Size and Original Size fields are set to 0, since when the Local File Header is written, no further data has been read and so this information is not available. When the file has been read fully, a Data Descriptor will be written, which contains relevant information. The following Extra Field is emitted: Extended Timestamp, see Packmatic.Field.Shared.ExtendedTimestamp"},{"ref":"Packmatic.Field.Local.FileHeader.html#t:t/0","title":"Packmatic.Field.Local.FileHeader.t/0","type":"type","doc":""},{"ref":"Packmatic.Field.Shared.ExtendedInformation.html","title":"Packmatic.Field.Shared.ExtendedInformation","type":"module","doc":"Represents the Zip64 Extended Information Extra Field, which can be emitted in both Local and Central File Headers, but in practice only used in the Central File Header within Packmatic, due to its streaming nature. Furthermore, disregarding the APPNOTE’s indication that the field should only be used if the sizes are set to 0xFF 0xFF / 0xFF 0xFF 0xFF 0xFF, since Packmatic always skips the file sizes in the Local File Header (due to the archive being generated in a streaming fashionn), and always emits the sizes in the Central Directory File Header as 0xFF 0xFF 0xFF 0xFF for simplicity, the Zip64 Extended Information Extra Field is never emitted by Packmatic in the Local File Header, and always emitted by Packmatic in the Central Directory File Header, with both Uncompressed and Compressed Sizes. Structure Shared Zip64 Extended Information SizeContent 2 bytesSignature 2 bytesSize of Rest of Field (Bytes) 8 bytesOriginal Size (Bytes) 8 bytesCompressed Size (Bytes)"},{"ref":"Packmatic.Field.Shared.ExtendedInformation.html#t:t/0","title":"Packmatic.Field.Shared.ExtendedInformation.t/0","type":"type","doc":""},{"ref":"Packmatic.Field.Shared.ExtendedTimestamp.html","title":"Packmatic.Field.Shared.ExtendedTimestamp","type":"module","doc":"Represents the Extended Timestamp Extra Field, which is emitted in both Local and Central File Headers. The field is emitted with only the modification time, in seconds since UNIX epoch (1 January, 1970). Structure Shared Extended Timestamp (UTc) SizeContent 2 bytesSignature 2 bytesSize of Rest of Field (Bytes) 1 byteFlags 4 bytesModification Time (Seconds since UNIX Epoch) Notes The flag value is 1, representing that Modification Time is set."},{"ref":"Packmatic.Field.Shared.ExtendedTimestamp.html#t:t/0","title":"Packmatic.Field.Shared.ExtendedTimestamp.t/0","type":"type","doc":""},{"ref":"Packmatic.Field.Shared.Timestamp.html","title":"Packmatic.Field.Shared.Timestamp","type":"module","doc":"The Shared Timestamp field is emitted in both Local and Central File Headers, and is emitted in DOS (FAT) format. The time and date components are represented as little-endian, 16-bit integers, though they are first built separately Structure SizeContent 2 bytesHour (5 bits), Minute (6 bits), Second / 2 (5 bits) 2 bytesYear Since 1980 (7 bits), Month (4 bits), Day (5 bits) Notes See Erlang/OTP: :zip.dos_date_time_to_datetime/2. If the Timestamp given is prior to midnight, 1 January, 1980, it is also coerced to midnight, 1 January, 1980. If the Timestamp is on or after midnight, 1 January, 2108, then it can no longer be correctly represented within the limitations of the underlying field, and so is coerced to the previous representatable tick: 23:58, 31 December, 2107."},{"ref":"Packmatic.Field.Shared.Timestamp.html#t:t/0","title":"Packmatic.Field.Shared.Timestamp.t/0","type":"type","doc":""},{"ref":"Packmatic.Manifest.html","title":"Packmatic.Manifest","type":"module","doc":"Represents the customer’s request for a particular compressed file, which is composed of various Source Entries."},{"ref":"Packmatic.Manifest.html#create/1","title":"Packmatic.Manifest.create/1","type":"function","doc":""},{"ref":"Packmatic.Manifest.html#prepend/2","title":"Packmatic.Manifest.prepend/2","type":"function","doc":""},{"ref":"Packmatic.Manifest.html#t:entry/0","title":"Packmatic.Manifest.entry/0","type":"type","doc":""},{"ref":"Packmatic.Manifest.html#t:t/0","title":"Packmatic.Manifest.t/0","type":"type","doc":""},{"ref":"Packmatic.Manifest.Entry.html","title":"Packmatic.Manifest.Entry","type":"module","doc":"Represents a particular file that will go into package, which is sourced by reading from a file, downloading from an URI, etc. The source in the Manifest Entry is actually just a Source Entry which will be dynamically resolved at runtime when it is time for the Encoder to start reading from it."},{"ref":"Packmatic.Manifest.Entry.html#t:source/0","title":"Packmatic.Manifest.Entry.source/0","type":"type","doc":""},{"ref":"Packmatic.Manifest.Entry.html#t:t/0","title":"Packmatic.Manifest.Entry.t/0","type":"type","doc":""},{"ref":"Packmatic.Source.html","title":"Packmatic.Source","type":"behaviour","doc":"Defines how data can be acquired in a piecemeal fashion, perhaps by reading only a few pages from the disk at a time or only a few MBs of data from an open socket."},{"ref":"Packmatic.Source.html#build/1","title":"Packmatic.Source.build/1","type":"function","doc":"Transforms an Entry into a Source ready for acquisition. Called by Packmatic.Encoder."},{"ref":"Packmatic.Source.html#c:init/1","title":"Packmatic.Source.init/1","type":"callback","doc":"Converts the Entry to a Source, or return failure."},{"ref":"Packmatic.Source.html#read/1","title":"Packmatic.Source.read/1","type":"function","doc":"Consumes bytes off an initialised Source. Called by Packmatic.Encoder."},{"ref":"Packmatic.Source.html#c:read/1","title":"Packmatic.Source.read/1","type":"callback","doc":"Iterates the Source and return data as an IO List, :eof, or failure."},{"ref":"Packmatic.Source.html#t:entry/0","title":"Packmatic.Source.entry/0","type":"type","doc":""},{"ref":"Packmatic.Source.html#t:entry_dynamic/0","title":"Packmatic.Source.entry_dynamic/0","type":"type","doc":""},{"ref":"Packmatic.Source.html#t:entry_file/0","title":"Packmatic.Source.entry_file/0","type":"type","doc":""},{"ref":"Packmatic.Source.html#t:entry_random/0","title":"Packmatic.Source.entry_random/0","type":"type","doc":""},{"ref":"Packmatic.Source.html#t:entry_url/0","title":"Packmatic.Source.entry_url/0","type":"type","doc":""},{"ref":"Packmatic.Source.Dynamic.html","title":"Packmatic.Source.Dynamic","type":"module","doc":"Represents content which may be generated on-demand, for example by another subsystem or via downloading from a signed URL. The Dynamic source has no read function, and must initialise into a File or URL Source."},{"ref":"Packmatic.Source.Dynamic.html#init/1","title":"Packmatic.Source.Dynamic.init/1","type":"function","doc":""},{"ref":"Packmatic.Source.Dynamic.html#t:entry/0","title":"Packmatic.Source.Dynamic.entry/0","type":"type","doc":""},{"ref":"Packmatic.Source.Dynamic.html#t:resolve_fun/0","title":"Packmatic.Source.Dynamic.resolve_fun/0","type":"type","doc":""},{"ref":"Packmatic.Source.Dynamic.html#t:t/0","title":"Packmatic.Source.Dynamic.t/0","type":"type","doc":""},{"ref":"Packmatic.Source.File.html","title":"Packmatic.Source.File","type":"module","doc":"Represents content on disk, for example from a static file. Also useful for content generated ahead of time."},{"ref":"Packmatic.Source.File.html#t:entry/0","title":"Packmatic.Source.File.entry/0","type":"type","doc":""},{"ref":"Packmatic.Source.File.html#t:t/0","title":"Packmatic.Source.File.t/0","type":"type","doc":""},{"ref":"Packmatic.Source.Random.html","title":"Packmatic.Source.Random","type":"module","doc":"Represents randomly generated content, which is used mostly for testing, when you want to have a particular entry generated to a specific length."},{"ref":"Packmatic.Source.Random.html#t:entry/0","title":"Packmatic.Source.Random.entry/0","type":"type","doc":""},{"ref":"Packmatic.Source.Random.html#t:t/0","title":"Packmatic.Source.Random.t/0","type":"type","doc":""},{"ref":"Packmatic.Source.URL.html","title":"Packmatic.Source.URL","type":"module","doc":"Represents content which can be acquired by downloading from a remote server via HTTP(S) in chunks. Each chunk is then pulled away by the Encoder, which is iterated by the Stream."},{"ref":"Packmatic.Source.URL.html#t:entry/0","title":"Packmatic.Source.URL.entry/0","type":"type","doc":""},{"ref":"Packmatic.Source.URL.html#t:t/0","title":"Packmatic.Source.URL.t/0","type":"type","doc":""},{"ref":"Packmatic.StreamError.html","title":"Packmatic.StreamError","type":"exception","doc":""},{"ref":"readme.html","title":"Packmatic","type":"extras","doc":"Packmatic Packmatic generates Zip Streams by aggregating File or URL Sources. By using a Stream, the caller can compose it within the confines of Plug’s request/response model and serve the content of the resultant Zip acrhive in a streaming fashion. This allows fast delivery of a Zip archive consisting of many disparate parts hosted in different places, without having to first spool all of them to disk. The generated archive uses Zip64, and works with individual files that are larger than 4GB. See the Compatibility section for more information."},{"ref":"readme.html#introduction","title":"Packmatic - Introduction","type":"extras","doc":"The Problem In modern Web applications, content is often stored away from the host, such as Amazon S3, to enable better scalability and resiliency, as data would not be lost should a particular host go down. However, one disadvantage of this design is that data has become more spread-out, so previously simple operations such as creation of a Zip archive consisting of various files is now more complicated. In a hypothetical scenario where the developer opts for synchronous generation, the process may spend too long preparing the constituent files, which breaks certain connection proxies which expect a reasonable time to first byte. And in any case, disk utilisation will be high, since not only does each constituent file need to be on disk, there must be free space that will hold the archive temporarily as well. In another hypothetical scenario, where the developer opts for asynchronous generation, spooling still has to happen and further infrastructure for background job execution, user notification, temporary storage, etc. is now needed, which increases complexity. The Solution The overall goal for Packmatic is to deliver a modern Zip streamer, which is able to assemble a Zip file from various sources, such as HTTP(S) downloads or locally generated temporary files, on-the-fly, so as to minimise waiting time, reduce resource consumption and elevate customer happiness. Packmatic solves the problem by separating the concerns of content definition (specifying what content should be retrieved, and from where), data retrieval (getting the content from the given source), and content presentation (creation of the Archive bundle). With Packmatic, the developer first specifies a list of Source Entries, which indicates where content can be obtained, and in what way: downloaded from the Internet, read from the filesystem, or dynamically resolved when the archive is being built, etc. This information is then wrapped in a Stream, which is consumed to send out chunked responses. When the Stream is started, it spins up an Encoder process, which works in a staged, iterative manner. This allows downloads to start almost immediately, which enhances customer happiness. The Encoder consumes the manifest as the Stream is consumed. In other words, the Stream starts producing data only when the client starts reading, and only as fast as the client reads, which reduces the amount of networking and local storage needed to start the process. Most of the acquisition work is interleaved, and back-pressured by client connection speed. Furthermore, since Packmatic only streams what it needs, and does not spool content locally, it is possible to produce large archives whose constituent files do not fit on one host. This is an advantage over conventional processes, where even in a synchronous scenario, all constituent files and the archive must be spooled to disk. This design enhances developer happiness as well, since by using a synchronous, iterative mode of operation, there is no longer any need to spool constituent files in the archive on disk; there is also no longer any need to build technical workarounds in order to compensate for archive preparation delays. With Packmatic, both the problem and the solution is drastically simplified. The user clicks “download”, and the file starts downloading. This is how it should be."},{"ref":"readme.html#installation","title":"Packmatic - Installation","type":"extras","doc":"To install Packmatic, add the following line in your application’s dependencies: defp deps do [ {:packmatic, &quot;~&gt; 0.1.1&quot;} ] end"},{"ref":"readme.html#usage","title":"Packmatic - Usage","type":"extras","doc":"In order to use Packmatic, you will first create such a Stream by Packmatic.build_stream/2. You can then send it off for download with help from Packmatic.Conn.send_chunked/3. Internally, this is powered by Packmatic.Encoder, which consumes the Entries within a built Manifest iteratively at the pace set by the client’s download connection. Each Source Entry within the Manifest specifies the source from where to obtain the content of a particular file to be placed in the package, and which path to put it under; it is your own responsibility to ensure that paths are not duplicated (see the Notes for an example). Building Stream The usual way to construct a Stream is as follows. entries = [ {{:file, &quot;/tmp/hello.pdf&quot;}, &quot;hello.pdf&quot;}, {{:file, &quot;/tmp/world.pdf&quot;}, &quot;world.pdf&quot;}, {{:url, &quot;https://example.com/foo.pdf&quot;}, &quot;foo/bar.pdf&quot;} ] stream = Packmatic.build_stream(entries) If you desire, you may pass an additional option entry to Packmatic.build_stream/2, such as: stream = Packmatic.build_stream(entries, on_error: :skip) Each Entry used to build the Stream is a 2-arity tuple, representing the Source Entry and the Path for the file. Further, the Source Entry is a 2-arity tuple which represents the type of Source and the initialising argument of that type of Source. See Source Types. Writing Stream to File stream |&gt; Stream.into(File.stream!(file_path, [:write])) |&gt; Stream.run() Writing Stream to Conn (with Plug) stream |&gt; Packmatic.Conn.send_chunked(conn, &quot;download.zip&quot;) When writing the stream to a chunked Plug.Conn, Packmatic automatically escapes relevant characters in the name and sets the Content Disposition to attachment for maximum browser compatibility under intended use."},{"ref":"readme.html#source-types","title":"Packmatic - Source Types","type":"extras","doc":"Within Packmatic, there are four types of Sources: File, representing content on disk, useful when the content is already available and only needs to be integrated. Example: {:file, &quot;/tmp/hello/pdf&quot;}. See Packmatic.Source.File. URL, representing content that is available remotely. Packmatic will run a chunked download routine to incrementally download and archive available chunks. Example: {:url, &quot;https://example.com/hello/pdf&quot;}. See Packmatic.Source.URL. Random, representing randomly generated bytes which is useful for testing. Example: {:random, 1048576}. See Packmatic.Source.Random. Dynamic, representing a dynamically resolved Source, which is ultimately fulfilled by pulling content from either a File or an URL. If you have any need to inject a dynamically generated file, you may use this Source type to do it. This also has the benefit of avoiding expensive computation work in case the customer abandons the download midway. Example: {:dynamic, fn -&gt; {:ok, {:random, 1048576}} end}. See Packmatic.Source.Dynamic."},{"ref":"readme.html#notes","title":"Packmatic - Notes","type":"extras","doc":"As with any user-generated content, you should exercise caution when building the Manifest, and ensure that only content that the User is entitled to retrieve is included. Due to design limitations, when downloading resources via a HTTP(S) connection, should the connection become closed halfway, a partial representation may be embedded in the output. A future release of this library may correct this in case the Content-Length header is present in the output, and act accordingly. You must ensure that paths are not duplicated within the same Manifest. You can do this by first building a list of sources and paths, then grouping and numbering them as needed with Enum.group_by/3. Given entries are {source, path} tuples, you can do this: annotate_fun = fn entries -&gt; for {{source, path}, index} &lt;- Enum.with_index(entries) do path_components = Path.split(path) {path_components, [filename]} = Enum.split(path_components, -1) extname = Path.extname(filename) basename = Path.basename(filename, extname) path_components = path_components ++ [&quot;\#{basename} (\#{index + 1})\#{extname}&quot;] {source, Path.join(path_components)} end end duplicates_fun = fn [_ | [_ | _]] = entries -&gt; annotate_fun.(entries) entries -&gt; entries end entries |&gt; Enum.group_by(&amp; elem(&amp;1, 1)) |&gt; Enum.flat_map(&amp;duplicates_fun.(elem(&amp;1, 1))) You must ensure that paths conform to the target environment of your choice, for example macOS and Windows each has its limitations regarding how long paths can be. Compatibility Windows Windows Explorer (Windows 10): OK 7-Zip: OK macOS Finder (High Sierra): OK The Unarchiver (High Sierra): NG Erlang/OTP (:zip): NG Known Issues Ability to switch between STORE and DEFLATE modes is under investigation. Currently all archives are generated with DEFLATE, although for some use cases, this only increases the size of the archive, as content within each file is already compressed. Can not change compression level. Explicit directory generation is not supported; each entry must be a file. This is pending further investigation. Handling of 0-length files from sources is pending further investigation. Currently, they do get journaled but this may change in the future. Future Enhancements We will consider adding ability to resume downloads with range queries, so if the URL Source fails we can attempt to resume encoding from where we left off. In practice, if there are large files that are archived repeatedly, they will be pulled repeatedly and there is currently no explicit ability to cache them. We expect that in these cases an optimisation by the application developer may be to temporarily spool these hot constituents on disk and use a Dynamic Source to wrap around the cache layer (which would emit a File Source if the file is available locally, and act accordingly otherwise)."},{"ref":"readme.html#acknowledgements","title":"Packmatic - Acknowledgements","type":"extras","doc":"During design and prototype development of this library, the Author has drawn inspiration from the following implementations, and therefore thanks all contributors for their generosity: ctrabant/fdzipstream dgvncsz0f/zipflow"},{"ref":"readme.html#reference","title":"Packmatic - Reference","type":"extras","doc":"https://users.cs.jmu.edu/buchhofp/forensics/formats/pkzip.html https://pkware.cachefly.net/webdocs/casestudies/APPNOTE.TXT"}]